#include <stdint.h>
#include <assert.h>
#include <stdio.h>

void get_u64_0(const uint8_t *wire, uint64_t *r)
{
	*r = (uint64_t)wire[0];
	*r |= (uint64_t)wire[1] << 8;
	*r |= (uint64_t)wire[2] << 16;
	*r |= (uint64_t)wire[3] << 24;
	*r |= (uint64_t)wire[4] << 32;
	*r |= (uint64_t)wire[5] << 40;
	*r |= (uint64_t)wire[6] << 48;
	*r |= (uint64_t)wire[7] << 56;
}

void get_u64_0b(const uint8_t *wire, uint64_t *r)
{
	*r	= (uint64_t)wire[0]
		| (uint64_t)wire[1] << 8
		| (uint64_t)wire[2] << 16
		| (uint64_t)wire[3] << 24
		| (uint64_t)wire[4] << 32
		| (uint64_t)wire[5] << 40
		| (uint64_t)wire[6] << 48
		| (uint64_t)wire[7] << 56;
}

void get_u64_1(const uint8_t *wire, uint64_t *r)
{
	*r = *(uint64_t*)wire;
}


void get_u64_3(const uint8_t *wire, uint64_t *r)
{
	*r = (uint64_t)*wire++;
	*r |= (uint64_t)*wire++ << 8;
	*r |= (uint64_t)*wire++ << 16;
	*r |= (uint64_t)*wire++ << 24;
	*r |= (uint64_t)*wire++ << 32;
	*r |= (uint64_t)*wire++ << 40;
	*r |= (uint64_t)*wire++ << 48;
	*r |= (uint64_t)*wire++ << 56;
}

void get_u64_2(const uint8_t *wire, uint64_t *r)
{
	int x = 7;
	wire+=7;
	*r = (uint64_t)*wire--;
	do {
		*r <<= 8;
		*r |= (uint64_t)*wire--;
	} while (--x);
}

int main(int argc, char *argv[])
{
	uint64_t data[] = {0,1,0x10,0x100,0x1000,0x10000,UINT64_MAX};
	int i;
	for (i = 0; i < sizeof(data)/sizeof(data[0]); ++i) {
		uint64_t r0,r1,r2;
		get_u64_0((uint8_t*)data+i,&r0);
		get_u64_1((uint8_t*)data+i,&r1);
		get_u64_2((uint8_t*)data+i,&r2);
		assert(r0 == r1);
		assert(r0 == r2);
	}
	printf("%s: OK\n",argv[0]);
	return 0;
}
